!  subroutine of reading data from the previous cycle
!! in the file recup.tmp generated by the previous run
!!
! ******************************************************************
module Lecture_DonneesCyclePrecedent_m
use stics_system
use messages
USE Stics
USE Plante
USE Root
USE Itineraire_Technique
USE Sol
USE Parametres_Generaux
implicit none
private
public :: Lecture_DonneesCyclePrecedent
contains
  subroutine Lecture_DonneesCyclePrecedent(logger, path, sc, pg, p, r, itk, soil)
  type(logger_), intent(in) :: logger
  character(*), intent(in) :: path
  type(Stics_Communs_),       intent(INOUT) :: sc  
  type(Parametres_Generaux_), intent(INOUT) :: pg
  type(Plante_),              intent(INOUT) :: p(sc%P_nbplantes)
  type(Root_),                intent(INOUT) :: r(sc%P_nbplantes)
  type(ITK_),                 intent(INOUT) :: itk(sc%P_nbplantes)
  type(Sol_),                 intent(INOUT) :: soil

! dr 25/09/2014 resuuite0 danscette version comporte au plus 31 caracteres et non 7 comme dans la 69, je corrige .
      character(len=31)   :: ressuite0(2)
      character(len=8)   :: codeplante0(2)  
      character(len=250) :: tmp  
      integer            :: idx
      integer            :: i
      integer            :: iz
      integer            :: ir
      integer            :: icou
      integer            :: ifwater0p1
      integer            :: nbresid        ! nombre de types de residus en mulch
      integer            :: irac
      integer            :: nbcourac
      integer            :: nzero
      ! PL: 10/4/2019, Nombre de plantes usm precedente
      integer :: nbplant_prev
      real :: P_profdrain, epc
      
      integer :: recup, iostat
      logical :: exists

      exists = path_exist(path)
      
      if (.not. exists) then
        call exit_error(logger, "recup.tmp file doesn't exist: [" // path // "]")
      end if

      open (newunit=recup, file=path, status=old, action=read_, iostat=iostat)
      if (iostat .ne. 0) then
        call exit_error(logger, "Error opening recup.tmp file: [" // path // "]")
      end if

      nbresid = (pg%nbResidus-1)/2


        ! PL: 2/4/2019, Ajout du nombre de plantes de l'usm precedente !
        read(recup,*) sc%nbjrecol0, sc%ifwater0, sc%nhe, sc%dernier_n, &
        & sc%codeenteterap, nbplant_prev

        ! TODO : P_codeperenne, sur la plante principale ? sur toutes les plantes ?
        if (sc%ifwater0 == sc%nbjrecol0 .and. p(1)%P_codeperenne /= 2) then
          if (sc%P_iwater /= 1) then
            call exit_error(logger, MESSAGE_3045)
          endif
        else
        ! PB 04/2010 : on cherche a comparer P_iwater au jour de fin du cycle precedent + 1
        ! (le cycle doit reprendre le jour suivant celui de fin du cycle precedent)
        ! mais si le cycle precedent s'est termine le dernier jour de l'annee (365 par ex.)
        ! alors, le jour suivant est 366, alors que P_iwater a deja etait affecte a 1.
        ! Et donc le test P_iwater /= ifwater0 + 1 est tjs vrai (1 /= 366)
        ! Pour pallier a ce probleme, on borne ifwater0 + 1 par nbjrecol0 (nb de jours de l'annee du cycle precedent)
        ! Le jour 366 devient le jour 1, et donc le test devient faux et le programme ne s'interrompt pas
        ! sur une mauvaise interpretation.
          ifwater0p1 = sc%ifwater0 + 1
          if (ifwater0p1 > sc%nbjrecol0) ifwater0p1 = ifwater0p1 - sc%nbjrecol0
          if (sc%P_iwater /= ifwater0p1) then
            call exit_error(logger, MESSAGE_3045)
          endif
        endif
! Modif Bruno mars 2018
        read(recup,*) sc%NH
        read(recup,*) (sc%Hinit(i),i = 1,sc%NH)     !5)
        read(recup,*) (soil%NO3init(i),i = 1,sc%NH) !5)
        read(recup,*) (sc%NH4init(i),i = 1,sc%NH)   !5)
        read(recup,*) (sc%TS(i),i = 1,sc%NH)        !5)
        read(recup,*)  sc%tcultveille, sc%tairveille
        sc%tcult = sc%tcultveille

 !  Bruno mai 2012 : prise en compte de tous les pools C et N organiques
        read(recup,*) sc%Chumt,sc%Chuma,sc%Chumi,sc%Nhumt,sc%Nhuma,sc%Nhumi,sc%Cr,sc%Nr,sc%Cb,sc%Nb,sc%Cmulchnd,sc%Nmulchnd, &
                   sc%Cmulchdec,sc%Nmulchdec,sc%Cbmulch,sc%Nbmulch,sc%Crprof,sc%Nrprof
 !  Bruno  Initialisations pour bilan
        sc%Nb0 = sc%Nb
        sc%Cb0 = sc%Cb
        sc%Nr0 = sc%Nr
        sc%Cr0 = sc%Cr
        sc%Chuma0 = sc%Chuma
        sc%Nhuma0 = sc%Nhuma
        sc%Chumi0 = sc%Chumi
        sc%Nhumi0 = sc%Nhumi
 ! Modifs Bruno et Loic et Elsa sept2012 : Cmulch et Nmulch n'ont pas ete transmis donc on refait la somme ici
        sc%Cmulch0 = sc%Cmulchdec + sc%Cmulchnd
        sc%Nmulch0 = sc%Nmulchdec + sc%Nmulchnd
        sc%Cbmulch0 = sc%Cbmulch
        sc%Nbmulch0 = sc%Nbmulch
        sc%Crprof0 = sc%Crprof
        sc%Nrprof0 = sc%Nrprof

 ! lecture des parametres de decomposition des differents types de residus
 !  Bruno aout 2012 : ajout de Cnondec et Nnondec
      do ir = 1,pg%nbResidus
         read(recup,*) sc%kres(ir),pg%P_kbio(ir),sc%hres(ir),sc%Wb(ir)
      end do
      do ir = 1,nbResid
         read(recup,*) sc%Cnondec(ir),sc%Nnondec(ir)
      end do

 ! Modif Looc 2016: je lis les residus jusqu'a obstarac car on a maintenant des residus de racines mortes, en-dessous de profhum
      irac = int(soil%P_obstarac)

      do ir = 1,pg%nbResidus
            read(recup,*) nzero
            read(recup,*) (sc%Cres(iz,ir),iz=1,irac-nzero)
            read(recup,*) nzero
            read(recup,*) (sc%Nres(iz,ir),iz=1,irac-nzero)
            read(recup,*) nzero
            read(recup,*) (sc%Cbio(iz,ir),iz=1,irac-nzero)
            read(recup,*) nzero
            read(recup,*) (sc%Nbio(iz,ir),iz=1,irac-nzero)
      enddo
      read(recup,*) nzero
      read(recup,*) (sc%Chum(iz),iz=1,irac-nzero)
      read(recup,*) nzero
      read(recup,*) (sc%Nhum(iz),iz=1,irac-nzero)

 ! lecture de l'etat du sol, couche elementaire (1 cm) par couche elementaire
        do  iz = 1, sc%nhe
          read(recup,*) sc%hur(iz), sc%sat(iz), soil%nit(iz), soil%amm(iz), sc%tsolveille(iz)
        end do


        read(recup,*)soil%P_numsol,soil%P_typsol,soil%P_argi,soil%P_Norg,soil%P_profhum,soil%P_calc,soil%P_pH0,&
                          soil%P_concseuil,soil%P_albedo,soil%P_q0,soil%P_ruisolnu,soil%P_obstarac,soil%P_pluiebat, &
                          soil%P_mulchbat,soil%P_zesx,soil%P_cfes,soil%P_z0solnu ,soil%CsurNsol, soil%P_penterui

        read(recup,*) soil%P_numsol,soil%P_codecailloux,soil%P_codemacropor,soil%P_codefente,   &
                          soil%P_codrainage,soil%P_coderemontcap,soil%P_codenitrif,soil%P_codedenit

        read(recup,*) soil%P_numsol,soil%P_profimper,soil%P_ecartdrain,soil%P_ksol,soil%P_profdrain,     &
                          soil%P_capiljour,soil%P_humcapil,soil%P_profdenit,soil%P_vpotdenit

        ! if( soil%P_profdenit) == 0. ) soil%P_profdenit = soil%P_profhum
        if(abs(soil%P_profdenit).lt.1.0E-8) soil%P_profdenit = soil%P_profhum

        do icou = 1, sc%NH   !5
          read(recup,*) soil%P_numsol,soil%P_epc(icou),soil%P_hccf(icou),soil%P_hminf(icou),soil%P_DAF(icou),  &  ! DR 02/10/2012
                     soil%P_cailloux(icou),soil%P_typecailloux(icou),soil%P_infil(icou),soil%P_epd(icou)
        end do

    ! domi 14/03/06 ecriture des caracteristiques permanentes du sol dans history
    ! en faisant cela, on repete le sol lors d'enchainement : il vaudrait mieux deplacer ce morceau
        call EnvoyerMsgHistorique(logger, MESSAGE_501)
        call EnvoyerMsgHistorique(logger, MESSAGE_502)
        write(tmp,'(a12,17f7.2)') soil%P_typsol,soil%P_argi,soil%P_Norg,soil%P_profhum,      &
                                  soil%P_calc,soil%P_pH0,soil%P_concseuil,soil%P_albedo,     &
                                  soil%P_q0,soil%P_ruisolnu,soil%P_obstarac,soil%P_pluiebat, &
                                  soil%P_mulchbat,soil%P_zesx,soil%P_cfes,soil%P_z0solnu,    &
                                  soil%P_CsurNsol0, soil%P_penterui
        call EnvoyerMsgHistorique(logger, tmp)
        call EnvoyerMsgHistorique(logger, MESSAGE_503)

        write(tmp,'(i7,6i11)') soil%P_codecailloux,soil%P_codemacropor,soil%P_codefente,  &
                               soil%P_codrainage,soil%P_coderemontcap,soil%P_codenitrif,soil%P_codedenit
        call EnvoyerMsgHistorique(logger, tmp)
        call EnvoyerMsgHistorique(logger, MESSAGE_504)
        ! 06/04/2012 je corrige le format d'ecriture depuis ajout profdenit et vpotdenit
        write(tmp,'(8f8.1)')soil%P_profimper,soil%P_ecartdrain,soil%P_ksol,real(soil%P_profdrain),     &
                          soil%P_capiljour,soil%P_humcapil,soil%P_profdenit,soil%P_vpotdenit
        call EnvoyerMsgHistorique(logger, tmp)
        call EnvoyerMsgHistorique(logger, MESSAGE_505)

        do icou = 1,sc%NH    !5
          write(tmp,'(f7.0,2f7.1,f7.2,2f7.0,2i7)')                          &
            real(soil%P_epc(icou)),soil%P_hccf(icou),soil%P_hminf(icou),soil%P_DAF(icou),  &
            soil%P_cailloux(icou),soil%P_infil(icou),soil%P_epd(icou),soil%P_typecailloux(icou)
          call EnvoyerMsgHistorique(logger, tmp)
        end do

 ! dans le cas d'un enchainement
    if (pg%P_codeinitprec == 2) then  ! Instruction redondante car l'appel de Lecture_Donnees (dans initnonsol) ne se fait que si codeinitprec = 2
        ! PL: 10/4/2019, nombre de plantes de l'usm precedente lu au debut nbplant_prev !
        !do idx = 1, sc%P_nbplantes
        do idx = 1, nbplant_prev
          read(recup,*,end=900)
          read(recup,*) codeplante0(idx)
          read(recup,*) ressuite0(idx)

          if (index(ressuite0(idx),'stubble+roots')>0 .or. index(ressuite0(idx),'straw+roots')>0  &
            .or. index(ressuite0(idx),'stubbleveg')>0 .or. index(ressuite0(idx),'whole_crop')>0) then
! Bruno juin 2017 modif pour pouvoir apporter un residu de type 2 en cas d'enchainement
!            if (itk(idx)%P_coderes(1) == 1 .or. itk(idx)%P_coderes(1) == 2) itk(idx)%P_qres(1) = 0.
             if (itk(idx)%P_coderes(1) == 1) itk(idx)%P_qres(1) = 0.
          endif

          read(recup,*) p(idx)%P_lai0,  p(idx)%P_masecnp0, p(idx)%P_magrain0,                    &
                     p(idx)%P_zrac0, p(idx)%P_QNplantenp0, p(idx)%P_restemp0, p(idx)%resperenne(AOAS), &
                     p(idx)%P_maperenne0, p(idx)%QNresperenne(AOAS), p(idx)%P_QNperenne0, p(idx)%resperennestruc, &
! Modif Loic Juin 2021 : les parametres msrac0 QNrac0 et QNrestemp0 n'existent plus
!                     p(idx)%QNresperennestruc, t%P_msrac0, t%P_QNrac0, t%P_QNrestemp0, &
                     p(idx)%QNresperennestruc, p(idx)%msrac0, p(idx)%QNrac0, p(idx)%QNrestemp0, &
                     p(idx)%mafeuil0, p(idx)%mafeuilverte0, p(idx)%matigestruc0,   &
                     p(idx)%somcourno0, p(idx)%ndno0, p(idx)%nfno0,         &
                     p(idx)%QNfeuille0, p(idx)%QNtige0, p(idx)%msresgel0, p(idx)%QNresgel0, &
                     p(idx)%QNabsotot(AS), p(idx)%QNabsotot(AO), p(idx)%Qfixtot(AS), p(idx)%Qfixtot(AO), &
                     ! Ajout Florent C. et Fabien, Octobre 2019
                     p(idx)%Qfix0

          read(recup,*) p(idx)%cu0
          read(recup,*) (p(idx)%P_densinitial(i),i = 1, sc%NH)    !5)

 ! On lit le profil seulement jusqu'a zrac (=nbcourac)
 !        nbcourac = nint(p(idx)%P_zrac0) + 1
          nbcourac = int(p(idx)%P_zrac0 + 0.999999)

            read(recup,*) p(idx)%ndecalf, p(idx)%ndecalg, p(idx)%ndebsenracf, p(idx)%ndebsenracg, p(idx)%somtempracvie
            do iz = 1,nbcourac
               read(recup,*) p(idx)%rlf0(iz), p(idx)%rlg0(iz)
            end do
! Bruno novembre 2018 : remise a 0 des tableaux rlf0 et rlg0 en dessous de nbcourac
            do iz = nbcourac+1, nbCouchesSol
               p(idx)%rlf0(iz) = 0.
               p(idx)%rlg0(iz) = 0.
            end do

! on lit le nombre de valeurs nulles (nzero) et on ne lit que les valeurs non nulles

! modif Bruno septembre 2018 : permutation des lignes et colonnes de drlf et drlg
            do iz = 1,nbcourac
                read(recup,*) nzero
!               read(recup,*) (r(idx)%drlf(i,iz), i=1,p(idx)%ndecalf-nzero)
                read(recup,*) (r(idx)%drlf(iz,i), i=1,p(idx)%ndecalf-nzero)
! Bruno novembre 2018 : remise a 0 du tableau drlf (qui est fait seulement dans initnonsol pour des annuelles, depart sol nu)
                do i = p(idx)%ndecalf-nzero +1, maxdayf
                   r(idx)%drlf(iz,i) = 0.
                enddo
            enddo
            do iz = 1,nbcourac
                read(recup,*) nzero
!               read(recup,*) (r(idx)%drlg(i,iz), i=1,p(idx)%ndecalg-nzero)
                read(recup,*) (r(idx)%drlg(iz,i), i=1,p(idx)%ndecalg-nzero)
! Bruno novembre 2018 : remise a 0 du tableau drlg (qui est fait seulement dans initnonsol pour des annuelles, depart sol nu)
                do i = p(idx)%ndecalg-nzero +1, maxdayg
                   r(idx)%drlg(iz,i) = 0.
                enddo
            enddo

! fin modif
            read(recup,*) nzero
            do i = 1,p(idx)%ndecalg - nzero
               read(recup,*) p(idx)%dtj(i)
            enddo

        end do  ! nb plantes

        if (sc%P_nbplantes == 2) then
          if ((p(1)%P_codeplante /= codeplante0(1) .or. p(2)%P_codeplante /= codeplante0(2))) &
                call EnvoyerMsgHistorique(logger, MESSAGE_450)
        end if
     endif  ! fin lecture pour enchainement


900   close(recup)

        soil%profsol = 0
        do i = 1, sc%NH     !5
          soil%profsol = soil%profsol + soil%P_epc(i)
        end do
return
end subroutine Lecture_DonneesCyclePrecedent
end module Lecture_DonneesCyclePrecedent_m
 
